<template>
	<a-drawer
		:title="'车辆预约审批'"
		:width="800"
		:visible="visible"
		:destroy-on-close="true"
		:footer-style="{ textAlign: 'right' }"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="审批：" name="depotOpApprovalState">
				<a-radio-group v-model:value="formData.depotOpApprovalState" placeholder="请选择"
							   :options="[{label:'通过',value:'已审批'},{label:'未通过',value:'未通过'}]"/>
			</a-form-item>
			<a-form-item label="审批信息：" name="depotOpApprovalMsg">
				<a-textarea v-model:value="formData.depotOpApprovalMsg" placeholder="请输入审批信息" :auto-size="{ minRows: 3, maxRows: 10 }"/>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</a-drawer>
</template>

<script setup name="depotTruckBookForm">
import tool from '@/utils/tool'
import {cloneDeep} from 'lodash-es'
import {required, rules} from '@/utils/formRules'
import depotTruckBookApi from '@/api/biz/depotTruckBookApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi"
// 抽屉状态
const visible = ref(false)
const emit = defineEmits({successful: null})
const formRef = ref()
// 表单数据
const formData = ref({})
const submitLoading = ref(false)

// 打开抽屉
const onOpen = (record) => {
	visible.value = true
	if (record) {
		let recordData = cloneDeep(record)
		formData.value = Object.assign({}, recordData)
		formData.value.depotOpApprovalState = '已审批'
	}
}
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields()
	formData.value = {}
	visible.value = false
}
// 默认要校验的
const formRules = {
	depotOpApprovalState: [required('请选择')],
}
// 验证并提交数据
const onSubmit = () => {
	formRef.value
		.validate()
		.then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			depotTruckBookApi
				.depotOpApproval(formDataParam)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
}
// 抛出函数
defineExpose({
	onOpen
})
const depotOpApprovalStateOptions = tool.dictList('审批状态')
</script>
